svrName = inputbox("Enter Server Name","Server Name")

set itemManagement = CreateObject("Altiris.ASDK.NS.ItemManagement")
itemManagement.TargetServer = svrName
itemManagement.Authenticate()

'------Database Table Size SORTING USAGE @SortOrder int VALUES--------
'/   0 = Alphabetically by table name [Table_Name]
'/   1 = Sorted by table size [Total Space Used]
'/   2 = Sorted by all table sizes
'---------------------------------------------------------------------


query = "set nocount on " _ 
& "declare @CmdStr varchar(200) " _
& "declare @SortOrder int " _
& "set @SortOrder = 2 " _
& "if (object_id('tempdb..#Temp_Table') is null) begin " _
& "create table #Temp_Table ( " _
& "[Table_Name] varchar(200), " _
& "[Row_Count] int, " _
& "[Table_Size] varchar(50), " _
& "[Data_Space_Used] varchar(50), " _
& "[Index_Space_Used] varchar(50), " _
& "[Unused_Space] varchar(50)) " _ 
& "end " _
& "else begin " _
& "truncate table #Temp_Table " _
& "end " _
& "set @CmdStr = " & chr(39) & "sp_msforeachtable " & chr(39) & chr(39)& "sp_spaceused " & chr(34) & "?" & chr(34) & chr(39) & chr(39) & chr(39) & " " _
& "insert into #Temp_Table execute(@CmdStr) " _
& "if (@SortOrder = 0) begin " _
& "select " _
& "[Product Name] = vp.[name] " _
& ",[Table Name] = tt.[Table_Name] " _
& ",[Type] = case cast(dc.[ClassType] as int) " _
& "when '0' then 'User' " _
& "when '1' then 'Event' " _
& "when '2' then 'Common' " _
& "end " _
& ",[Row Count] = tt.[Row_Count] " _
& ",[Total (KB)] = cast(substring(tt.[Table_Size], 1, charindex(' ',tt.[Table_Size]))as int) " _
& ",[Data (KB)] = cast(substring(tt.[Data_Space_Used], 1, charindex(' ',tt.[Data_Space_Used]))as int) " _
& ",[Index (KB)] = cast(substring([Index_Space_Used], 1, charindex(' ',tt.[Index_Space_Used]))as int) " _
& ",[Unused (KB)] = cast(substring(tt.[Unused_Space], 1, charindex(' ',tt.[Unused_Space]))as int) " _
& "from #Temp_Table tt " _
& "join DataClass dc on dc.[DataTableName] = tt.[Table_Name] " _
& "or dc.[HistoryTableName] = tt.[Table_Name] " _
& "join item it on it.[guid] = dc.[guid] " _
& "join vProduct vp on it.[ProductGuid] = vp.[guid] " _
& "where cast(substring(tt.[Data_Space_Used], 1, charindex(' ',tt.[Data_Space_Used]))as int) > 0 " _
& "order by [Product Name], [Type], [Table_Name] " _
& "end " _
& "if (@SortOrder = 1) begin " _
& "select " _
& "[Product Name] = vp.[name] " _
& ",[Table Name] = tt.[Table_Name] " _
& ",[Type] = case cast(dc.[ClassType] as int) " _
& "when '0' then 'User' " _
& "when '1' then 'Event' " _
& "when '2' then 'Common' " _
& "end " _
& ",[Row Count] = tt.[Row_Count] " _
& ",[Total (KB)] = cast(substring(tt.[Table_Size], 1, charindex(' ',tt.[Table_Size]))as int) " _
& ",[Data (KB)] = cast(substring(tt.[Data_Space_Used], 1, charindex(' ',tt.[Data_Space_Used]))as int) " _
& ",[Index (KB)] = cast(substring(tt.[Index_Space_Used], 1, charindex(' ',tt.[Index_Space_Used]))as int) " _
& ",[Unused (KB)] = cast(substring(tt.[Unused_Space], 1, charindex(' ',tt.[Unused_Space]))as int) " _
& "from #Temp_Table tt " _
& "join DataClass dc on dc.[DataTableName] = tt.[Table_Name] " _
& "or dc.[HistoryTableName] = tt.[Table_Name] " _
& "join item it on it.[guid] = dc.[guid] " _
& "join vProduct vp on it.[ProductGuid] = vp.[guid] " _
& "where cast(substring(tt.[Data_Space_Used], 1, charindex(' ',tt.[Data_Space_Used]))as int) > 0 " _
& "order by [Total (KB)] desc, [Table_Name] " _
& "end " _
& "if (@SortOrder = 2) begin " _
& "select " _
& "[Product Name] = isnull(vp.[name], 'Core') " _
& ",[Table Name] = tt.[Table_Name] " _
& ",[Type] = case cast(dc.[ClassType] as int) " _
& "when '0' then 'User' " _
& "when '1' then 'Event' " _
& "when '2' then 'Common' " _
& "else 'Core' " _
& "end " _
& ",[Row Count] = tt.[Row_Count] " _
& ",[Total (KB)] = cast(substring(tt.[Table_Size], 1, charindex(' ',tt.[Table_Size]))as int) " _
& ",[Data (KB)] = cast(substring(tt.[Data_Space_Used], 1, charindex(' ',tt.[Data_Space_Used]))as int) " _
& ",[Index (KB)] = cast(substring(tt.[Index_Space_Used], 1, charindex(' ',tt.[Index_Space_Used]))as int) " _
& ",[Unused (KB)] = cast(substring(tt.[Unused_Space], 1, charindex(' ',tt.[Unused_Space]))as int) " _
& "from #Temp_Table tt " _
& "left join DataClass dc on dc.[DataTableName] = tt.[Table_Name] " _
& "or dc.[HistoryTableName] = tt.[Table_Name] " _
& "left join item it on it.[guid] = dc.[guid] " _
& "left join vProduct vp on it.[ProductGuid] = vp.[guid] " _
& "where cast(substring(tt.[Data_Space_Used], 1, charindex(' ',tt.[Data_Space_Used]))as int) > 0 " _
& "order by [Total (KB)] desc, [Table_Name] " _
& "end"

set results = itemManagement.ExecuteNSDatabaseQuery(query)

if results.Fields.Count > 0 then 

Set objExcel = CreateObject("Excel.Application")
objExcel.Visible = True
objExcel.Workbooks.Add
objExcel.Cells(1, 1).Value = "Product Name"
objExcel.Cells(1, 2).Value = "Table Name"
objExcel.Cells(1, 3).Value = "Row Count"
objExcel.Cells(1, 4).Value = "Total KB"
objExcel.Range("A1:D1").Select
objExcel.Selection.Interior.ColorIndex = 19
objExcel.Selection.Font.ColorIndex = 11
objExcel.Selection.Font.Bold = True
objExcel.Cells.EntireColumn.AutoFit

results.MoveFirst() 

intRow = 3

do while not results.EOF 

prdName = results.Fields.Item(0).Value
tblName = results.Fields.Item(1).Value
rowCount= results.Fields.Item(3).Value
totalKB = results.Fields.Item(4).Value 

objExcel.Cells(intRow, 1).Value = prdName
objExcel.Cells(intRow, 2).Value = tblName
objExcel.Cells(intRow, 3).Value = rowCount
objExcel.Cells(intRow, 4).Value = totalKB

results.MoveNext()

intRow = intRow + 1

loop 

end if 


